﻿
Namespace FileAccess

    ''' <summary>
    ''' Wird ausgelöst, wenn eine Datei mit einer ungültigen Version geladen wird.
    ''' </summary>
    Public Class FileVersionException
        Inherits Exception

        Dim _Version As Version
        ''' <summary>
        ''' Die Version der ungültigen Datei.
        ''' </summary>
        Public ReadOnly Property Version As Version
            Get
                Return _Version
            End Get
        End Property

        Public Sub New(NewMessage As String, NewVersion As Version)
            MyBase.new(NewMessage & " Version: " & NewVersion.ToString)
            _Version = NewVersion
        End Sub

    End Class

End Namespace
