﻿
''' <summary>
''' Nimmt das Master-Passwort entgegen.
''' </summary>
Public Class MainPasswordDialog

    ''' <summary>
    ''' Das eingegebene Master-Passwort.
    ''' </summary>
    Public ReadOnly Property Password As String
        Get
            'Return New System.Text.UTF8Encoding(False).GetBytes()
            Return ViewModel.Password
        End Get
    End Property

    ''' <summary>
    ''' Gibt an, ob das Passwort wiederholt werden muss (z.B. beim Speichern, um Tippfehler auszuschließen).
    ''' </summary>
    Public Property Repeat As Boolean
        Get
            Return ViewModel.ShowRepeatBox
        End Get
        Set(value As Boolean)
            ViewModel.ShowRepeatBox = value
        End Set
    End Property

    Dim ViewModel As MainPasswordDialogViewModel

    Public Sub New()
        InitializeComponent()
        ViewModel = DirectCast(Me.DataContext, MainPasswordDialogViewModel)
        PasswordBox.Focus()
        'PasswordBox unterstützt kein Binding für das Passwort.
        AddHandler PasswordBox.PasswordChanged, AddressOf OnPasswordChanged
        AddHandler RepeatPasswordBox.PasswordChanged, AddressOf OnRepeatPasswordChanged
    End Sub

    Private Sub OnPasswordChanged(sender As Object, e As RoutedEventArgs)
        ViewModel.Password = PasswordBox.Password
    End Sub

    Private Sub OnRepeatPasswordChanged(sender As Object, e As RoutedEventArgs)
        ViewModel.RepeatPassword = RepeatPasswordBox.Password
    End Sub

    Private Sub CloseOk(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Me.DialogResult = True
        Me.Close()
    End Sub

    Private Sub CloseCancel(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Me.DialogResult = False
        Me.Close()
    End Sub

End Class
