Public Class MainPasswordDialogViewModel
    Inherits ViewModelBase

    Dim _Password As String
    Public Property Password As String
        <DebuggerStepThrough()> _
        Get
            Return _Password
        End Get
        Set(value As String)
            ChangeIfDifferent(_Password, value, "Password")
        End Set
    End Property

    Dim _RepeatPassword As String
    Public Property RepeatPassword As String
        <DebuggerStepThrough()> _
        Get
            Return _RepeatPassword
        End Get
        Set(value As String)
            ChangeIfDifferent(_RepeatPassword, value, "RepeatPassword")
        End Set
    End Property

    Dim _ShowRepeatBox As Boolean
    Public Property ShowRepeatBox As Boolean
        Get
            Return _ShowRepeatBox
        End Get
        Set(value As Boolean)
            ChangeIfDifferent(_ShowRepeatBox, value, "ShowRepeatBox")
        End Set
    End Property

    <Dependency("ShowRepeatBox", "Password", "RepeatPassword")>
    Public ReadOnly Property CloseOkEnabled As Boolean
        Get
            Return _
                Not String.IsNullOrEmpty(_Password) _
                AndAlso _
                (
                    Not _ShowRepeatBox _
                    OrElse _
                    _Password = _RepeatPassword
                )
        End Get
    End Property

    Public Sub New()
        MyBase.New(True)
    End Sub

End Class