﻿Class MainWindowViewModel
    Inherits ViewModelBase

    Public Event EditPassword(Sender As PasswordViewModel)
    Public Event RemovePassword(Sender As PasswordViewModel)

    Dim WithEvents _Passwords As ViewModelCollection(Of Password, PasswordViewModel) = Nothing
    Public Property Passwords As ViewModelCollection(Of Password, PasswordViewModel)
        Get
            Return _Passwords
        End Get
        Set(value As ViewModelCollection(Of Password, PasswordViewModel))
            If ChangeIfDifferent(_Passwords, value) Then
                'Getrennt, weil WithEvents.
                OnPropertyChanged("Passwords")
            End If
        End Set
    End Property

    Public Sub New()
        MyBase.New(True)
        If IsInDesignMode Then
            Dim Temp As New ObservableCollection(Of Password)
            Passwords = New ViewModelCollection(Of Password, PasswordViewModel)(New ObservableCollectionSource(Of Password)(Temp))
            Temp.Add(New Password With {.Description = "Test", .UserName = "Sepp", .Password = "Bla Blubb"})
            Temp.Add(New Password With {.Description = "Hallo Welt fewaionföoeaw aw efg", .UserName = "Hallo Welt fewaionföoeaw aw efg", .Password = "fawefwf"})
            Temp.Add(New Password With {.Description = "Foo", .UserName = "hans.wurst@banana.de", .Password = "fawoöeifnawöoe fiawoef wöaoeifnawefw"})
        End If
    End Sub

    Private Sub Passwords_ItemAdded(sender As Object, e As OnUtils.Wpf.ViewModelCollectionItemAddedEventArgs(Of Password, PasswordViewModel)) Handles _Passwords.ItemAdded
        e.ViewModel = New PasswordViewModel(e.Item)
        AddHandler e.ViewModel.Edit, AddressOf OnEditPassword
        AddHandler e.ViewModel.Remove, AddressOf OnRemovePassword
    End Sub

    Private Sub Passwords_ItemRemoved(sender As Object, e As OnUtils.Wpf.ViewModelCollectionItemRemovedEventArgs(Of Password, PasswordViewModel)) Handles _Passwords.ItemRemoved
        RemoveHandler e.ViewModel.Edit, AddressOf OnEditPassword
        RemoveHandler e.ViewModel.Remove, AddressOf OnRemovePassword
    End Sub

    Private Sub OnEditPassword(Sender As PasswordViewModel)
        RaiseEvent EditPassword(Sender)
    End Sub

    Private Sub OnRemovePassword(Sender As PasswordViewModel)
        RaiseEvent RemovePassword(Sender)
    End Sub

End Class
