﻿
''' <summary>
''' Nimmt ein Passwort entgegen.
''' </summary>
Public Class PasswordDialog

    ''' <summary>
    ''' Der eingegebene Benutzername.
    ''' </summary>
    Public Property UserName As String
        Get
            Return ViewModel.UserName
        End Get
        Set(value As String)
            ViewModel.UserName = value
        End Set
    End Property

    ''' <summary>
    ''' Das eingegebene Passwort.
    ''' </summary>
    Public Property Password As String
        Get
            Return ViewModel.Password
        End Get
        Set(value As String)
            'ViewModel.Password = value
            PasswordBox.Password = value
        End Set
    End Property

    ''' <summary>
    ''' Die eingegebene Beschreibung.
    ''' </summary>
    Public Property Description As String
        Get
            Return ViewModel.Description
        End Get
        Set(value As String)
            ViewModel.Description = value
        End Set
    End Property

    Dim ViewModel As PasswordDialogViewModel

    Public Sub New()
        InitializeComponent()
        ViewModel = DirectCast(Me.DataContext, PasswordDialogViewModel)
        'PasswortBox unterstützt kein Binding für das Passwort.
        AddHandler PasswordBox.PasswordChanged, AddressOf PasswordBox_PasswordChanged
    End Sub

    Private Sub PasswordBox_PasswordChanged(sender As Object, e As RoutedEventArgs)
        ViewModel.Password = PasswordBox.Password
    End Sub

    Private Sub CloseOk(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Me.DialogResult = True
        Me.Close()
    End Sub

    Private Sub CloseCancel(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Me.DialogResult = False
        Me.Close()
    End Sub

    Private Sub GeneratePassword(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Dim Dlg As New GeneratePasswordDialog
        If Dlg.ShowDialog Then
            PasswordBox.Password = Dlg.Password
        End If
    End Sub

End Class
