﻿Public Class PasswordViewModel
    Inherits ViewModelBase(Of Password)

    Public Event Edit(Sender As PasswordViewModel)
    Public ReadOnly Property EditCommand As DelegateCommand
        Get
            Static Temp As New DelegateCommand(Sub() RaiseEvent Edit(Me))
            Return Temp
        End Get
    End Property

    Public Event Remove(Sender As PasswordViewModel)
    Public ReadOnly Property RemoveCommand As DelegateCommand
        Get
            Static Temp As New DelegateCommand(Sub() RaiseEvent Remove(Me))
            Return Temp
        End Get
    End Property

    Public ReadOnly Property CopyCommand As DelegateCommand
        Get
            Static Temp As New DelegateCommand(Sub() Clipboard.SetText(Target.Password))
            Return Temp
        End Get
    End Property

    Public ReadOnly Property MaskedPassword As String
        Get
            Return New String("*"c, Target.Password.Length)
        End Get
    End Property

    Public Sub New(NewTarget As Password)
        MyBase.New(NewTarget)
        AddHandler Target.PropertyChanged, AddressOf Target_PropertyChanged
    End Sub

    Private Sub Target_PropertyChanged(sender As Object, e As PropertyChangedEventArgs)
        Select Case e.PropertyName
            Case "Text"
                OnPropertyChanged("MaskedPassword")
        End Select
    End Sub

End Class
